#ifndef GBOX_H
#define GBOX_H

#include <config.h>
#include <gnome.h>
#include <libgnomeui/gnome-stock.h>
#include <libgnomeui/gnome-propertybox.h>
#include <gdk/gdkx.h>
#include <gdk_imlib.h>
#include <gtk/gtk.h>
#include <applet-widget.h>
#include "gbox_mailbox.h"

typedef struct _gbox_applet GboxApplet;
typedef struct _icons Icons;

struct _gbox_applet {
  gchar          *no_mail_pix;
  gchar          *new_mail_pix[COUNT_PRIORITY];
  gchar          *mail_prog;
  GtkWidget      *image_win;
  GtkWidget      *mailcheck;
/*    GtkWidget      *main_button; */
  GtkWidget      *mail_count;
  GtkWidget      *fixed_box;
  int            mail_count_prio;
  int            mail_count_x_pos;
  int            mail_count_y_pos;
  gchar          *font_name;
  GtkWidget      *gbox_applet;
  GtkStyle       *style;
  GdkImlibImage  *no_email_image;
  GdkPixmap      *no_email_pixmap;
  GdkBitmap      *no_email_mask;
  GdkImlibImage  *new_email_image[COUNT_PRIORITY];
  GdkPixmap      *new_email_pixmap[COUNT_PRIORITY];
  GdkBitmap      *new_email_mask[COUNT_PRIORITY];
  GtkWidget      *tip;
  GtkTooltips    *tooltip;
  int            prop_box_active;
  int            style_beep;
/*    int            style_relief; */
  int            show_mail_count;
  int            show_tooltip;
  int            style_tooltip;
  int            pos_tooltip;
};

struct _icons {
  GtkWidget *no_mail;
  GtkWidget *pix_no_mail;
  gchar     *file_no_mail;
  GtkWidget *new_mail[COUNT_PRIORITY];
  GtkWidget *pix_new_mail[COUNT_PRIORITY];
  gchar     *file_new_mail[COUNT_PRIORITY];
};

void update_tooltip(void);
void update_mailboxes_cb(AppletWidget *app, gpointer data);
int check_mailbox(MailBox *mb);
void set_mail_icon(void);
gint timeout_callback( gpointer data );
void start_timer(void);
void stop_timer(void);
void load_image(gchar *file, GdkImlibImage **image, GdkPixmap **pixmap, GdkBitmap **mask);

//void show_tooltip(GtkButton *button, gpointer user_data);
void show_tooltip(GtkWidget *widget, GdkEvent *evt, gpointer user_data);
//void hide_tooltip(GtkButton *button, gpointer user_data);
void hide_tooltip(GtkWidget *widget, GdkEvent *evt, gpointer user_data);
void row_length(char **text);
void store_iconfile(GtkFileSelection *selector, gpointer user_data);
void select_iconfile(GtkWidget* w, gpointer cbdata);
void store_mailprog(GtkFileSelection *selector, gpointer user_data);
void select_mailprog(GtkWidget* w, gpointer cbdata);
/*  void menu_changed(GtkWidget* w, gpointer cbdata); */
void move_down_cb(GtkWidget* w, gpointer cbdata);
void move_up_cb(GtkWidget* w, gpointer cbdata);
void add_box_cb(GtkWidget* w, gpointer cbdata);
void edit_box_cb(GtkWidget* w, gpointer cbdata);
void remove_or_not(gint reply,gpointer data);
void remove_box_cb(GtkWidget* w, gpointer cbdata);
void copy_box_cb(GtkWidget* w, gpointer cbdata);
void text_changed(GtkWidget* w, gpointer cbdata);
void apply_prop_cb(GtkWidget* propertybox, gint page_num, gpointer data);
void close_prop_cb(GtkWidget* propertybox, gint page_num, gpointer data);
GtkWidget *create_page_global(void);
GtkWidget *create_page_prio(void);
GtkWidget *create_page_misc(void);
GtkWidget *create_page_defaults(void);
void mail_items(AppletWidget *app, gpointer data);
void applet_properties(AppletWidget *app, gpointer data);

#endif
